/// <reference types="react" />
import { Editor, Position } from 'codemirror';
import { IMarkdownEditor } from '../';
export declare type ButtonHandle = (command: ICommand, props: IMarkdownEditor, options: {
    preview?: HTMLDivElement | null;
    container?: HTMLDivElement | null;
    containerEditor?: HTMLDivElement | null;
    editor?: Editor;
}) => JSX.Element;
export declare type ICommand = {
    icon?: React.ReactElement;
    name?: string;
    keyCommand?: string;
    button?: ButtonHandle | React.ButtonHTMLAttributes<HTMLButtonElement>;
    execute?: (editor: Editor, selection: string, position: Position, opts: {
        preview?: HTMLDivElement | null;
        container?: HTMLDivElement | null;
    }) => void;
};
export declare const defaultCommands: {
    bold: ICommand;
    italic: ICommand;
    header: ICommand;
    strike: ICommand;
    underline: ICommand;
    olist: ICommand;
    ulist: ICommand;
    link: ICommand;
    todo: ICommand;
    image: ICommand;
    fullscreen: ICommand;
    preview: ICommand;
};
export declare const getCommands: () => ICommand[];
export declare const getModeCommands: () => ICommand[];
