/// <reference types="react" />
import CodeMirror from 'codemirror';
import './index.less';
import { ICommand, defaultCommands } from '../../commands';
import { IMarkdownEditor } from '../../';
export declare type IToolBarProps<T = (keyof (typeof defaultCommands)) | ICommand> = {
    className?: string;
    editorProps: IMarkdownEditor;
    mode?: boolean;
    preview?: HTMLDivElement | null;
    container?: HTMLDivElement | null;
    containerEditor?: HTMLDivElement | null;
    prefixCls?: string;
    editor?: CodeMirror.Editor;
    toolbars?: T[];
    onClick?: (type: string) => void;
};
export default function ToolBar(props: IToolBarProps): JSX.Element | null;
