/// <reference types="codemirror" />
import React from 'react';
import { ICodeMirror } from './components/CodeMirror';
import { MarkdownPreviewProps } from '@uiw/react-markdown-preview';
import { IToolBarProps } from './components/ToolBar';
import './index.less';
export * from './commands';
export interface IMarkdownEditor extends ICodeMirror {
    className?: string;
    prefixCls?: string;
    value?: string;
    height?: number;
    visible?: boolean;
    visibleEditor?: boolean;
    toolbars?: IToolBarProps['toolbars'];
    toolbarsMode?: IToolBarProps['toolbars'];
    previewProps?: MarkdownPreviewProps;
    options?: CodeMirror.EditorConfiguration;
}
export interface MarkdownEditorRef {
    editor?: CodeMirror.Editor;
    preview?: HTMLDivElement | null;
}
declare const _default: React.ForwardRefExoticComponent<Pick<IMarkdownEditor, string | number> & React.RefAttributes<MarkdownEditorRef>>;
export default _default;
